/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


//=====
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbvtkExtractVtkImageFilter.h"
#include "bbvtkPackage.h"
namespace bbvtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(vtk,ExtractVtkImageFilter)
BBTK_BLACK_BOX_IMPLEMENTATION(ExtractVtkImageFilter,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ExtractVtkImageFilter::Process()
{
	int voi[6];

	voi[0] = bbGetInputIndex()[0];
	voi[1] = bbGetInputIndex()[0]+bbGetInputSize()[0]-1;
	voi[2] = bbGetInputIndex()[1];
	voi[3] = bbGetInputIndex()[1]+bbGetInputSize()[1]-1;
	voi[4] = bbGetInputIndex()[2];
	voi[5] = bbGetInputIndex()[2]+bbGetInputSize()[2]-1;
	
	_extract->SetInput( bbGetInputIn() );
	_extract->SetVOI(voi);	
	_extract->UpdateWholeExtent();
	_extract->Modified();
	_extract->Update();
	bbSetOutputOut(_extract->GetOutput());
}
	
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ExtractVtkImageFilter::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
	
	_extract =NULL;

   bbSetInputIn(0);
	
	std::vector<int> tmpIndex;
	tmpIndex.push_back(0);
	tmpIndex.push_back(0);
	tmpIndex.push_back(0);
	std::vector<int> tmpSize;
	tmpSize.push_back(1);
	tmpSize.push_back(1);
	tmpSize.push_back(1);
	bbSetInputIndex(tmpIndex);
	bbSetInputSize(tmpSize);
	
	bbSetOutputOut(0);
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ExtractVtkImageFilter::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 
	_extract = vtkExtractVOI::New();

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ExtractVtkImageFilter::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any

	_extract->Delete();
}
}
// EO namespace bbvtk


